GEOS: geos::geomgraph::DirectedEdgeStar Class Reference

Public Member Functions

# geos::geomgraph::DirectedEdgeStar Class Reference

A DirectedEdgeStar is an ordered list of outgoing DirectedEdges around a node. More...

`#include <DirectedEdgeStar.h>`

Inheritance diagram for geos::geomgraph::DirectedEdgeStar:

List of all members.

## Public Member Functions
void | insert (EdgeEnd *ee)
| Insert a directed edge in the list.
Label & | getLabel ()
int | getOutgoingDegree ()
int | getOutgoingDegree (EdgeRing *er)
DirectedEdge * | getRightmostEdge ()
void | computeLabelling (std::vector< GeometryGraph * > *geom)
| Compute the labelling for all dirEdges in this star, as well as the overall labelling.
void | mergeSymLabels ()
| For each dirEdge in the star, merge the label from the sym dirEdge into the label.
void | updateLabelling (Label *nodeLabel)
| Update incomplete dirEdge labels from the labelling for the node.
void | linkResultDirectedEdges ()
void | linkMinimalDirectedEdges (EdgeRing *er)
void | linkAllDirectedEdges ()
void | findCoveredLineEdges ()
| Traverse the star of edges, maintaing the current location in the result area at this node (if any).
void | computeDepths (DirectedEdge *de)
| Compute the DirectedEdge depths for a subsequence of the edge array.
std::string | print ()

## Detailed Description

A DirectedEdgeStar is an ordered list of outgoing DirectedEdges around a node.

It supports labelling the edges as well as linking the edges to form both MaximalEdgeRings and MinimalEdgeRings.

## Member Function Documentation

void geos::geomgraph::DirectedEdgeStar::computeDepths | ( | DirectedEdge * | de ) |

Compute the DirectedEdge depths for a subsequence of the edge array.

Returns:
  the last depth assigned (from the R side of the last edge visited)

void geos::geomgraph::DirectedEdgeStar::findCoveredLineEdges | ( | ) |

Traverse the star of edges, maintaing the current location in the result area at this node (if any).

If any L edges are found in the interior of the result, mark them as covered.

void geos::geomgraph::DirectedEdgeStar::linkResultDirectedEdges | ( | ) |

Traverse the star of DirectedEdges, linking the included edges together. To link two dirEdges, the <next> pointer for an incoming dirEdge is set to the next outgoing edge.

DirEdges are only linked if:

- they belong to an area (i.e. they have sides)
- they are marked as being in the result

Edges are linked in CCW order (the order they are stored). This means that rings have their face on the Right (in other words, the topological location of the face is given by the RHS label of the DirectedEdge)

PRECONDITION: No pair of dirEdges are both marked as being in the result

The documentation for this class was generated from the following file:

- geomgraph/DirectedEdgeStar.h